# coding: utf-8

"""
    BIMData API

    BIMData API is a tool to interact with your models stored on BIMData’s servers.     Through the API, you can manage your projects, the clouds, upload your IFC files and manage them through endpoints.  # noqa: E501

    OpenAPI spec version: v1
    Contact: contact@bimdata.io
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from bimdata_api_client.api_client import ApiClient


class BcfApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_comment(self, projects_pk, topics_pk, comment, **kwargs):  # noqa: E501
        """Create a comment  # noqa: E501

        Create a comment Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_comment(projects_pk, topics_pk, comment, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Comment comment: (required)
        :return: Comment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_comment_with_http_info(projects_pk, topics_pk, comment, **kwargs)  # noqa: E501
        else:
            (data) = self.create_comment_with_http_info(projects_pk, topics_pk, comment, **kwargs)  # noqa: E501
            return data

    def create_comment_with_http_info(self, projects_pk, topics_pk, comment, **kwargs):  # noqa: E501
        """Create a comment  # noqa: E501

        Create a comment Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_comment_with_http_info(projects_pk, topics_pk, comment, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Comment comment: (required)
        :return: Comment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topics_pk', 'comment']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_comment" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `create_comment`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `create_comment`")  # noqa: E501
        # verify the required parameter 'comment' is set
        if ('comment' not in local_var_params or
                local_var_params['comment'] is None):
            raise ValueError("Missing the required parameter `comment` when calling `create_comment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'comment' in local_var_params:
            body_params = local_var_params['comment']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/comments', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Comment',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_full_topic(self, projects_pk, full_topic, **kwargs):  # noqa: E501
        """Create a Topic with viewpoints and comments  # noqa: E501

        This is not a standard route. You can send a topic, viewpoints and comments in a single call Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_full_topic(projects_pk, full_topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param FullTopic full_topic: (required)
        :return: FullTopic
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_full_topic_with_http_info(projects_pk, full_topic, **kwargs)  # noqa: E501
        else:
            (data) = self.create_full_topic_with_http_info(projects_pk, full_topic, **kwargs)  # noqa: E501
            return data

    def create_full_topic_with_http_info(self, projects_pk, full_topic, **kwargs):  # noqa: E501
        """Create a Topic with viewpoints and comments  # noqa: E501

        This is not a standard route. You can send a topic, viewpoints and comments in a single call Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_full_topic_with_http_info(projects_pk, full_topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param FullTopic full_topic: (required)
        :return: FullTopic
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'full_topic']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_full_topic" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `create_full_topic`")  # noqa: E501
        # verify the required parameter 'full_topic' is set
        if ('full_topic' not in local_var_params or
                local_var_params['full_topic'] is None):
            raise ValueError("Missing the required parameter `full_topic` when calling `create_full_topic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'full_topic' in local_var_params:
            body_params = local_var_params['full_topic']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/full-topic', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FullTopic',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_topic(self, projects_pk, topic, **kwargs):  # noqa: E501
        """Create a topic  # noqa: E501

        Create a topic Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_topic(projects_pk, topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param Topic topic: (required)
        :return: Topic
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_topic_with_http_info(projects_pk, topic, **kwargs)  # noqa: E501
        else:
            (data) = self.create_topic_with_http_info(projects_pk, topic, **kwargs)  # noqa: E501
            return data

    def create_topic_with_http_info(self, projects_pk, topic, **kwargs):  # noqa: E501
        """Create a topic  # noqa: E501

        Create a topic Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_topic_with_http_info(projects_pk, topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param Topic topic: (required)
        :return: Topic
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topic']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_topic" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `create_topic`")  # noqa: E501
        # verify the required parameter 'topic' is set
        if ('topic' not in local_var_params or
                local_var_params['topic'] is None):
            raise ValueError("Missing the required parameter `topic` when calling `create_topic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'topic' in local_var_params:
            body_params = local_var_params['topic']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Topic',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_viewpoint(self, projects_pk, topics_pk, viewpoint, **kwargs):  # noqa: E501
        """Create a Viewpoint  # noqa: E501

        Create a Viewpoint Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_viewpoint(projects_pk, topics_pk, viewpoint, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Viewpoint viewpoint: (required)
        :return: Viewpoint
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_viewpoint_with_http_info(projects_pk, topics_pk, viewpoint, **kwargs)  # noqa: E501
        else:
            (data) = self.create_viewpoint_with_http_info(projects_pk, topics_pk, viewpoint, **kwargs)  # noqa: E501
            return data

    def create_viewpoint_with_http_info(self, projects_pk, topics_pk, viewpoint, **kwargs):  # noqa: E501
        """Create a Viewpoint  # noqa: E501

        Create a Viewpoint Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_viewpoint_with_http_info(projects_pk, topics_pk, viewpoint, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Viewpoint viewpoint: (required)
        :return: Viewpoint
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topics_pk', 'viewpoint']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_viewpoint" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `create_viewpoint`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `create_viewpoint`")  # noqa: E501
        # verify the required parameter 'viewpoint' is set
        if ('viewpoint' not in local_var_params or
                local_var_params['viewpoint'] is None):
            raise ValueError("Missing the required parameter `viewpoint` when calling `create_viewpoint`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'viewpoint' in local_var_params:
            body_params = local_var_params['viewpoint']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Viewpoint',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_comment(self, guid, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Delete a comment  # noqa: E501

        Delete a comment Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_comment(guid, projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this comment. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_comment_with_http_info(guid, projects_pk, topics_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_comment_with_http_info(guid, projects_pk, topics_pk, **kwargs)  # noqa: E501
            return data

    def delete_comment_with_http_info(self, guid, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Delete a comment  # noqa: E501

        Delete a comment Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_comment_with_http_info(guid, projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this comment. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topics_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_comment" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `delete_comment`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `delete_comment`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `delete_comment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/comments/{guid}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_topic(self, guid, projects_pk, **kwargs):  # noqa: E501
        """Delete a topic  # noqa: E501

        Delete a topic Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_topic(guid, projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_topic_with_http_info(guid, projects_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_topic_with_http_info(guid, projects_pk, **kwargs)  # noqa: E501
            return data

    def delete_topic_with_http_info(self, guid, projects_pk, **kwargs):  # noqa: E501
        """Delete a topic  # noqa: E501

        Delete a topic Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_topic_with_http_info(guid, projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_topic" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `delete_topic`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `delete_topic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{guid}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_viewpoint(self, guid, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Delete a Viewpoint  # noqa: E501

        This is not a standard route. Delete a Viewpoint Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_viewpoint(guid, projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this viewpoint. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_viewpoint_with_http_info(guid, projects_pk, topics_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_viewpoint_with_http_info(guid, projects_pk, topics_pk, **kwargs)  # noqa: E501
            return data

    def delete_viewpoint_with_http_info(self, guid, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Delete a Viewpoint  # noqa: E501

        This is not a standard route. Delete a Viewpoint Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_viewpoint_with_http_info(guid, projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this viewpoint. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topics_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_viewpoint" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `delete_viewpoint`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `delete_viewpoint`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `delete_viewpoint`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints/{guid}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def download_bcf_export(self, id, **kwargs):  # noqa: E501
        """Export project's topics in bcf-xml format  # noqa: E501

        Export project's topics in bcf-xml format Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_bcf_export(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer value identifying this project. (required)
        :param str topics: topic guids to export, comma separated. Default = all
        :param str format: topic format to export, comma separated. Default = all
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.download_bcf_export_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.download_bcf_export_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def download_bcf_export_with_http_info(self, id, **kwargs):  # noqa: E501
        """Export project's topics in bcf-xml format  # noqa: E501

        Export project's topics in bcf-xml format Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_bcf_export_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer value identifying this project. (required)
        :param str topics: topic guids to export, comma separated. Default = all
        :param str format: topic format to export, comma separated. Default = all
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['id', 'topics', 'format']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method download_bcf_export" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in local_var_params or
                local_var_params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `download_bcf_export`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in local_var_params:
            path_params['id'] = local_var_params['id']  # noqa: E501

        query_params = []
        if 'topics' in local_var_params:
            query_params.append(('topics', local_var_params['topics']))  # noqa: E501
        if 'format' in local_var_params:
            query_params.append(('format', local_var_params['format']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{id}/export', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_bcf_project(self, id, bcf_project, **kwargs):  # noqa: E501
        """Update all fields of a BCF project  # noqa: E501

        Update all fields of a BCF project Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_bcf_project(id, bcf_project, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer value identifying this project. (required)
        :param BcfProject bcf_project: (required)
        :return: BcfProject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.full_update_bcf_project_with_http_info(id, bcf_project, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_bcf_project_with_http_info(id, bcf_project, **kwargs)  # noqa: E501
            return data

    def full_update_bcf_project_with_http_info(self, id, bcf_project, **kwargs):  # noqa: E501
        """Update all fields of a BCF project  # noqa: E501

        Update all fields of a BCF project Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_bcf_project_with_http_info(id, bcf_project, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer value identifying this project. (required)
        :param BcfProject bcf_project: (required)
        :return: BcfProject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['id', 'bcf_project']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_bcf_project" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in local_var_params or
                local_var_params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `full_update_bcf_project`")  # noqa: E501
        # verify the required parameter 'bcf_project' is set
        if ('bcf_project' not in local_var_params or
                local_var_params['bcf_project'] is None):
            raise ValueError("Missing the required parameter `bcf_project` when calling `full_update_bcf_project`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in local_var_params:
            path_params['id'] = local_var_params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'bcf_project' in local_var_params:
            body_params = local_var_params['bcf_project']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='BcfProject',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_comment(self, guid, projects_pk, topics_pk, comment, **kwargs):  # noqa: E501
        """Update all fields of a comment  # noqa: E501

        Update all fields of a comment Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_comment(guid, projects_pk, topics_pk, comment, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this comment. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Comment comment: (required)
        :return: Comment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.full_update_comment_with_http_info(guid, projects_pk, topics_pk, comment, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_comment_with_http_info(guid, projects_pk, topics_pk, comment, **kwargs)  # noqa: E501
            return data

    def full_update_comment_with_http_info(self, guid, projects_pk, topics_pk, comment, **kwargs):  # noqa: E501
        """Update all fields of a comment  # noqa: E501

        Update all fields of a comment Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_comment_with_http_info(guid, projects_pk, topics_pk, comment, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this comment. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Comment comment: (required)
        :return: Comment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topics_pk', 'comment']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_comment" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `full_update_comment`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `full_update_comment`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `full_update_comment`")  # noqa: E501
        # verify the required parameter 'comment' is set
        if ('comment' not in local_var_params or
                local_var_params['comment'] is None):
            raise ValueError("Missing the required parameter `comment` when calling `full_update_comment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'comment' in local_var_params:
            body_params = local_var_params['comment']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/comments/{guid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Comment',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_full_topic(self, guid, projects_pk, full_topic, **kwargs):  # noqa: E501
        """Update all fields of a topic  # noqa: E501

        This is not a standard route. You can update topic, viewpoints and comment is a signle call Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_full_topic(guid, projects_pk, full_topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :param FullTopic full_topic: (required)
        :return: FullTopic
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.full_update_full_topic_with_http_info(guid, projects_pk, full_topic, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_full_topic_with_http_info(guid, projects_pk, full_topic, **kwargs)  # noqa: E501
            return data

    def full_update_full_topic_with_http_info(self, guid, projects_pk, full_topic, **kwargs):  # noqa: E501
        """Update all fields of a topic  # noqa: E501

        This is not a standard route. You can update topic, viewpoints and comment is a signle call Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_full_topic_with_http_info(guid, projects_pk, full_topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :param FullTopic full_topic: (required)
        :return: FullTopic
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'full_topic']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_full_topic" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `full_update_full_topic`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `full_update_full_topic`")  # noqa: E501
        # verify the required parameter 'full_topic' is set
        if ('full_topic' not in local_var_params or
                local_var_params['full_topic'] is None):
            raise ValueError("Missing the required parameter `full_topic` when calling `full_update_full_topic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'full_topic' in local_var_params:
            body_params = local_var_params['full_topic']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/full-topic/{guid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FullTopic',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_topic(self, guid, projects_pk, topic, **kwargs):  # noqa: E501
        """Update all fields of a topic  # noqa: E501

        Update all fields of a topic Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_topic(guid, projects_pk, topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :param Topic topic: (required)
        :return: Topic
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.full_update_topic_with_http_info(guid, projects_pk, topic, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_topic_with_http_info(guid, projects_pk, topic, **kwargs)  # noqa: E501
            return data

    def full_update_topic_with_http_info(self, guid, projects_pk, topic, **kwargs):  # noqa: E501
        """Update all fields of a topic  # noqa: E501

        Update all fields of a topic Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_topic_with_http_info(guid, projects_pk, topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :param Topic topic: (required)
        :return: Topic
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topic']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_topic" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `full_update_topic`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `full_update_topic`")  # noqa: E501
        # verify the required parameter 'topic' is set
        if ('topic' not in local_var_params or
                local_var_params['topic'] is None):
            raise ValueError("Missing the required parameter `topic` when calling `full_update_topic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'topic' in local_var_params:
            body_params = local_var_params['topic']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{guid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Topic',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_viewpoint(self, guid, projects_pk, topics_pk, viewpoint, **kwargs):  # noqa: E501
        """Update all fields of a Viewpoint  # noqa: E501

        This is not a standard route. Update all fields of a Viewpoint Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_viewpoint(guid, projects_pk, topics_pk, viewpoint, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this viewpoint. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Viewpoint viewpoint: (required)
        :return: Viewpoint
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.full_update_viewpoint_with_http_info(guid, projects_pk, topics_pk, viewpoint, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_viewpoint_with_http_info(guid, projects_pk, topics_pk, viewpoint, **kwargs)  # noqa: E501
            return data

    def full_update_viewpoint_with_http_info(self, guid, projects_pk, topics_pk, viewpoint, **kwargs):  # noqa: E501
        """Update all fields of a Viewpoint  # noqa: E501

        This is not a standard route. Update all fields of a Viewpoint Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.full_update_viewpoint_with_http_info(guid, projects_pk, topics_pk, viewpoint, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this viewpoint. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Viewpoint viewpoint: (required)
        :return: Viewpoint
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topics_pk', 'viewpoint']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_viewpoint" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `full_update_viewpoint`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `full_update_viewpoint`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `full_update_viewpoint`")  # noqa: E501
        # verify the required parameter 'viewpoint' is set
        if ('viewpoint' not in local_var_params or
                local_var_params['viewpoint'] is None):
            raise ValueError("Missing the required parameter `viewpoint` when calling `full_update_viewpoint`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'viewpoint' in local_var_params:
            body_params = local_var_params['viewpoint']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints/{guid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Viewpoint',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_bcf_project(self, id, **kwargs):  # noqa: E501
        """Retrieve a BCF project  # noqa: E501

        Retrieve a BCF project Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_bcf_project(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer value identifying this project. (required)
        :return: BcfProject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_bcf_project_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_bcf_project_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def get_bcf_project_with_http_info(self, id, **kwargs):  # noqa: E501
        """Retrieve a BCF project  # noqa: E501

        Retrieve a BCF project Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_bcf_project_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer value identifying this project. (required)
        :return: BcfProject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_bcf_project" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in local_var_params or
                local_var_params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_bcf_project`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in local_var_params:
            path_params['id'] = local_var_params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='BcfProject',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_bcf_projects(self, **kwargs):  # noqa: E501
        """Retrieve all BCF projects  # noqa: E501

        Retrieve all BCF projects Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_bcf_projects(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: list[BcfProject]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_bcf_projects_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_bcf_projects_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_bcf_projects_with_http_info(self, **kwargs):  # noqa: E501
        """Retrieve all BCF projects  # noqa: E501

        Retrieve all BCF projects Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_bcf_projects_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: list[BcfProject]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_bcf_projects" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[BcfProject]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_colorings(self, projects_pk, topics_pk, viewpoints_pk, **kwargs):  # noqa: E501
        """Retrieve all colorings of a viewpoint  # noqa: E501

        Retrieve all colorings of a viewpoint Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_colorings(projects_pk, topics_pk, viewpoints_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param str viewpoints_pk: (required)
        :return: list[Coloring]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_colorings_with_http_info(projects_pk, topics_pk, viewpoints_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_colorings_with_http_info(projects_pk, topics_pk, viewpoints_pk, **kwargs)  # noqa: E501
            return data

    def get_colorings_with_http_info(self, projects_pk, topics_pk, viewpoints_pk, **kwargs):  # noqa: E501
        """Retrieve all colorings of a viewpoint  # noqa: E501

        Retrieve all colorings of a viewpoint Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_colorings_with_http_info(projects_pk, topics_pk, viewpoints_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param str viewpoints_pk: (required)
        :return: list[Coloring]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topics_pk', 'viewpoints_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_colorings" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_colorings`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `get_colorings`")  # noqa: E501
        # verify the required parameter 'viewpoints_pk' is set
        if ('viewpoints_pk' not in local_var_params or
                local_var_params['viewpoints_pk'] is None):
            raise ValueError("Missing the required parameter `viewpoints_pk` when calling `get_colorings`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501
        if 'viewpoints_pk' in local_var_params:
            path_params['viewpoints_pk'] = local_var_params['viewpoints_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints/{viewpoints_pk}/coloring', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Coloring]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_comment(self, guid, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve a comment  # noqa: E501

        Retrieve a comment Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_comment(guid, projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this comment. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: Comment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_comment_with_http_info(guid, projects_pk, topics_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_comment_with_http_info(guid, projects_pk, topics_pk, **kwargs)  # noqa: E501
            return data

    def get_comment_with_http_info(self, guid, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve a comment  # noqa: E501

        Retrieve a comment Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_comment_with_http_info(guid, projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this comment. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: Comment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topics_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_comment" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `get_comment`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_comment`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `get_comment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/comments/{guid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Comment',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_comments(self, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve all comments  # noqa: E501

        Retrieve all comments Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_comments(projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: list[Comment]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_comments_with_http_info(projects_pk, topics_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_comments_with_http_info(projects_pk, topics_pk, **kwargs)  # noqa: E501
            return data

    def get_comments_with_http_info(self, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve all comments  # noqa: E501

        Retrieve all comments Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_comments_with_http_info(projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: list[Comment]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topics_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_comments" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_comments`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `get_comments`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/comments', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Comment]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_extensions(self, projects_pk, **kwargs):  # noqa: E501
        """Retrieve project extensions  # noqa: E501

        Retrieve project extensions  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_extensions(projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :return: Extensions
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_extensions_with_http_info(projects_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_extensions_with_http_info(projects_pk, **kwargs)  # noqa: E501
            return data

    def get_extensions_with_http_info(self, projects_pk, **kwargs):  # noqa: E501
        """Retrieve project extensions  # noqa: E501

        Retrieve project extensions  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_extensions_with_http_info(projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :return: Extensions
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_extensions" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_extensions`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/extensions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Extensions',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_full_topic(self, guid, projects_pk, **kwargs):  # noqa: E501
        """Retrieve a full topic  # noqa: E501

        This is not a standard route. It responds with a topic, its viewpoints and its comments Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_full_topic(guid, projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :return: FullTopic
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_full_topic_with_http_info(guid, projects_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_full_topic_with_http_info(guid, projects_pk, **kwargs)  # noqa: E501
            return data

    def get_full_topic_with_http_info(self, guid, projects_pk, **kwargs):  # noqa: E501
        """Retrieve a full topic  # noqa: E501

        This is not a standard route. It responds with a topic, its viewpoints and its comments Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_full_topic_with_http_info(guid, projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :return: FullTopic
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_full_topic" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `get_full_topic`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_full_topic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/full-topic/{guid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FullTopic',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_full_topics(self, projects_pk, **kwargs):  # noqa: E501
        """Retrieve all full topics  # noqa: E501

        This is not a standard route. It responds with all topics, their viewpoints and their comments Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_full_topics(projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str ifcs: Filter the returned list by ifcs
        :param str format: Filter the returned list by format
        :return: list[FullTopic]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_full_topics_with_http_info(projects_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_full_topics_with_http_info(projects_pk, **kwargs)  # noqa: E501
            return data

    def get_full_topics_with_http_info(self, projects_pk, **kwargs):  # noqa: E501
        """Retrieve all full topics  # noqa: E501

        This is not a standard route. It responds with all topics, their viewpoints and their comments Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_full_topics_with_http_info(projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str ifcs: Filter the returned list by ifcs
        :param str format: Filter the returned list by format
        :return: list[FullTopic]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'ifcs', 'format']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_full_topics" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_full_topics`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []
        if 'ifcs' in local_var_params:
            query_params.append(('ifcs', local_var_params['ifcs']))  # noqa: E501
        if 'format' in local_var_params:
            query_params.append(('format', local_var_params['format']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/full-topic', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[FullTopic]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_selections(self, projects_pk, topics_pk, viewpoints_pk, **kwargs):  # noqa: E501
        """Retrieve all selections of a viewpoint  # noqa: E501

        Retrieve all selections of a viewpoint Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_selections(projects_pk, topics_pk, viewpoints_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param str viewpoints_pk: (required)
        :return: list[Component]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_selections_with_http_info(projects_pk, topics_pk, viewpoints_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_selections_with_http_info(projects_pk, topics_pk, viewpoints_pk, **kwargs)  # noqa: E501
            return data

    def get_selections_with_http_info(self, projects_pk, topics_pk, viewpoints_pk, **kwargs):  # noqa: E501
        """Retrieve all selections of a viewpoint  # noqa: E501

        Retrieve all selections of a viewpoint Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_selections_with_http_info(projects_pk, topics_pk, viewpoints_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param str viewpoints_pk: (required)
        :return: list[Component]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topics_pk', 'viewpoints_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_selections" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_selections`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `get_selections`")  # noqa: E501
        # verify the required parameter 'viewpoints_pk' is set
        if ('viewpoints_pk' not in local_var_params or
                local_var_params['viewpoints_pk'] is None):
            raise ValueError("Missing the required parameter `viewpoints_pk` when calling `get_selections`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501
        if 'viewpoints_pk' in local_var_params:
            path_params['viewpoints_pk'] = local_var_params['viewpoints_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints/{viewpoints_pk}/selection', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Component]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_snapshot(self, projects_pk, topics_pk, viewpoints_pk, **kwargs):  # noqa: E501
        """Retrieve the viewpoint' snapshot  # noqa: E501

        Retrieve the viewpoint' snapshot  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_snapshot(projects_pk, topics_pk, viewpoints_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param str viewpoints_pk: (required)
        :return: file
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_snapshot_with_http_info(projects_pk, topics_pk, viewpoints_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_snapshot_with_http_info(projects_pk, topics_pk, viewpoints_pk, **kwargs)  # noqa: E501
            return data

    def get_snapshot_with_http_info(self, projects_pk, topics_pk, viewpoints_pk, **kwargs):  # noqa: E501
        """Retrieve the viewpoint' snapshot  # noqa: E501

        Retrieve the viewpoint' snapshot  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_snapshot_with_http_info(projects_pk, topics_pk, viewpoints_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param str viewpoints_pk: (required)
        :return: file
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topics_pk', 'viewpoints_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_snapshot" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_snapshot`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `get_snapshot`")  # noqa: E501
        # verify the required parameter 'viewpoints_pk' is set
        if ('viewpoints_pk' not in local_var_params or
                local_var_params['viewpoints_pk'] is None):
            raise ValueError("Missing the required parameter `viewpoints_pk` when calling `get_snapshot`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501
        if 'viewpoints_pk' in local_var_params:
            path_params['viewpoints_pk'] = local_var_params['viewpoints_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints/{viewpoints_pk}/snapshot', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='file',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_topic(self, guid, projects_pk, **kwargs):  # noqa: E501
        """Retrieve a topic  # noqa: E501

        Retrieve a topic Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic(guid, projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :return: Topic
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_topic_with_http_info(guid, projects_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_topic_with_http_info(guid, projects_pk, **kwargs)  # noqa: E501
            return data

    def get_topic_with_http_info(self, guid, projects_pk, **kwargs):  # noqa: E501
        """Retrieve a topic  # noqa: E501

        Retrieve a topic Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_with_http_info(guid, projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :return: Topic
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_topic" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `get_topic`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_topic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{guid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Topic',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_topic_viewpoints(self, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve all viewpoints attached to the topic  # noqa: E501

        This is not a standard route. It returns all viewpoints of the topic that are not attached to a comment. Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_viewpoints(projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: list[Viewpoint]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_topic_viewpoints_with_http_info(projects_pk, topics_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_topic_viewpoints_with_http_info(projects_pk, topics_pk, **kwargs)  # noqa: E501
            return data

    def get_topic_viewpoints_with_http_info(self, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve all viewpoints attached to the topic  # noqa: E501

        This is not a standard route. It returns all viewpoints of the topic that are not attached to a comment. Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_viewpoints_with_http_info(projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: list[Viewpoint]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topics_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_topic_viewpoints" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_topic_viewpoints`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `get_topic_viewpoints`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/topic-viewpoints', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Viewpoint]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_topics(self, projects_pk, **kwargs):  # noqa: E501
        """Retrieve all topics  # noqa: E501

        Retrieve all topics Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topics(projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str ifcs: Filter the returned list by ifcs
        :param str format: Filter the returned list by format
        :return: list[Topic]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_topics_with_http_info(projects_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_topics_with_http_info(projects_pk, **kwargs)  # noqa: E501
            return data

    def get_topics_with_http_info(self, projects_pk, **kwargs):  # noqa: E501
        """Retrieve all topics  # noqa: E501

        Retrieve all topics Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topics_with_http_info(projects_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str ifcs: Filter the returned list by ifcs
        :param str format: Filter the returned list by format
        :return: list[Topic]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'ifcs', 'format']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_topics" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_topics`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []
        if 'ifcs' in local_var_params:
            query_params.append(('ifcs', local_var_params['ifcs']))  # noqa: E501
        if 'format' in local_var_params:
            query_params.append(('format', local_var_params['format']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Topic]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user(self, **kwargs):  # noqa: E501
        """Get current user info  # noqa: E501

        Get current user info Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: SelfBcfUser
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_user_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_user_with_http_info(self, **kwargs):  # noqa: E501
        """Get current user info  # noqa: E501

        Get current user info Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: SelfBcfUser
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/current-user', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SelfBcfUser',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_viewpoint(self, guid, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve a Viewpoint  # noqa: E501

        Retrieve a Viewpoint Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_viewpoint(guid, projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this viewpoint. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: Viewpoint
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_viewpoint_with_http_info(guid, projects_pk, topics_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_viewpoint_with_http_info(guid, projects_pk, topics_pk, **kwargs)  # noqa: E501
            return data

    def get_viewpoint_with_http_info(self, guid, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve a Viewpoint  # noqa: E501

        Retrieve a Viewpoint Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_viewpoint_with_http_info(guid, projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this viewpoint. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: Viewpoint
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topics_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_viewpoint" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `get_viewpoint`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_viewpoint`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `get_viewpoint`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints/{guid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Viewpoint',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_viewpoints(self, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve all Viewpoints of a topic  # noqa: E501

        Retrieve all Viewpoints of a topic Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_viewpoints(projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: list[Viewpoint]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_viewpoints_with_http_info(projects_pk, topics_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_viewpoints_with_http_info(projects_pk, topics_pk, **kwargs)  # noqa: E501
            return data

    def get_viewpoints_with_http_info(self, projects_pk, topics_pk, **kwargs):  # noqa: E501
        """Retrieve all Viewpoints of a topic  # noqa: E501

        Retrieve all Viewpoints of a topic Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_viewpoints_with_http_info(projects_pk, topics_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :return: list[Viewpoint]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topics_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_viewpoints" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_viewpoints`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `get_viewpoints`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Viewpoint]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_visibilities(self, projects_pk, topics_pk, viewpoints_pk, **kwargs):  # noqa: E501
        """Retrieve all visibilities of a viewpoint  # noqa: E501

        Retrieve all visibilities of a viewpoint Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_visibilities(projects_pk, topics_pk, viewpoints_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param str viewpoints_pk: (required)
        :return: list[Visibility]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_visibilities_with_http_info(projects_pk, topics_pk, viewpoints_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_visibilities_with_http_info(projects_pk, topics_pk, viewpoints_pk, **kwargs)  # noqa: E501
            return data

    def get_visibilities_with_http_info(self, projects_pk, topics_pk, viewpoints_pk, **kwargs):  # noqa: E501
        """Retrieve all visibilities of a viewpoint  # noqa: E501

        Retrieve all visibilities of a viewpoint Required scopes: bcf:read  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_visibilities_with_http_info(projects_pk, topics_pk, viewpoints_pk, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param str viewpoints_pk: (required)
        :return: list[Visibility]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'topics_pk', 'viewpoints_pk']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_visibilities" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `get_visibilities`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `get_visibilities`")  # noqa: E501
        # verify the required parameter 'viewpoints_pk' is set
        if ('viewpoints_pk' not in local_var_params or
                local_var_params['viewpoints_pk'] is None):
            raise ValueError("Missing the required parameter `viewpoints_pk` when calling `get_visibilities`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501
        if 'viewpoints_pk' in local_var_params:
            path_params['viewpoints_pk'] = local_var_params['viewpoints_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints/{viewpoints_pk}/visibility', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Visibility]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_bcf_project(self, id, bcf_project, **kwargs):  # noqa: E501
        """Update some fields of a BCF project  # noqa: E501

        Update some fields of a BCF project Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_bcf_project(id, bcf_project, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer value identifying this project. (required)
        :param BcfProject bcf_project: (required)
        :return: BcfProject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_bcf_project_with_http_info(id, bcf_project, **kwargs)  # noqa: E501
        else:
            (data) = self.update_bcf_project_with_http_info(id, bcf_project, **kwargs)  # noqa: E501
            return data

    def update_bcf_project_with_http_info(self, id, bcf_project, **kwargs):  # noqa: E501
        """Update some fields of a BCF project  # noqa: E501

        Update some fields of a BCF project Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_bcf_project_with_http_info(id, bcf_project, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: A unique integer value identifying this project. (required)
        :param BcfProject bcf_project: (required)
        :return: BcfProject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['id', 'bcf_project']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_bcf_project" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in local_var_params or
                local_var_params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `update_bcf_project`")  # noqa: E501
        # verify the required parameter 'bcf_project' is set
        if ('bcf_project' not in local_var_params or
                local_var_params['bcf_project'] is None):
            raise ValueError("Missing the required parameter `bcf_project` when calling `update_bcf_project`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in local_var_params:
            path_params['id'] = local_var_params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'bcf_project' in local_var_params:
            body_params = local_var_params['bcf_project']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{id}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='BcfProject',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_comment(self, guid, projects_pk, topics_pk, comment, **kwargs):  # noqa: E501
        """Update some fields of a comment  # noqa: E501

        Update some fields of a comment Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_comment(guid, projects_pk, topics_pk, comment, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this comment. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Comment comment: (required)
        :return: Comment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_comment_with_http_info(guid, projects_pk, topics_pk, comment, **kwargs)  # noqa: E501
        else:
            (data) = self.update_comment_with_http_info(guid, projects_pk, topics_pk, comment, **kwargs)  # noqa: E501
            return data

    def update_comment_with_http_info(self, guid, projects_pk, topics_pk, comment, **kwargs):  # noqa: E501
        """Update some fields of a comment  # noqa: E501

        Update some fields of a comment Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_comment_with_http_info(guid, projects_pk, topics_pk, comment, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this comment. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Comment comment: (required)
        :return: Comment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topics_pk', 'comment']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_comment" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `update_comment`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `update_comment`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `update_comment`")  # noqa: E501
        # verify the required parameter 'comment' is set
        if ('comment' not in local_var_params or
                local_var_params['comment'] is None):
            raise ValueError("Missing the required parameter `comment` when calling `update_comment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'comment' in local_var_params:
            body_params = local_var_params['comment']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/comments/{guid}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Comment',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_extensions(self, projects_pk, extensions, **kwargs):  # noqa: E501
        """Update project extensions  # noqa: E501

        Update project extensions  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_extensions(projects_pk, extensions, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param Extensions extensions: (required)
        :return: Extensions
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_extensions_with_http_info(projects_pk, extensions, **kwargs)  # noqa: E501
        else:
            (data) = self.update_extensions_with_http_info(projects_pk, extensions, **kwargs)  # noqa: E501
            return data

    def update_extensions_with_http_info(self, projects_pk, extensions, **kwargs):  # noqa: E501
        """Update project extensions  # noqa: E501

        Update project extensions  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_extensions_with_http_info(projects_pk, extensions, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str projects_pk: (required)
        :param Extensions extensions: (required)
        :return: Extensions
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['projects_pk', 'extensions']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_extensions" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `update_extensions`")  # noqa: E501
        # verify the required parameter 'extensions' is set
        if ('extensions' not in local_var_params or
                local_var_params['extensions'] is None):
            raise ValueError("Missing the required parameter `extensions` when calling `update_extensions`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'extensions' in local_var_params:
            body_params = local_var_params['extensions']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/extensions', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Extensions',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_full_topic(self, guid, projects_pk, full_topic, **kwargs):  # noqa: E501
        """Update some fields of a topic  # noqa: E501

        This is not a standard route. You can update topic, viewpoints and comment is a signle call Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_full_topic(guid, projects_pk, full_topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :param FullTopic full_topic: (required)
        :return: FullTopic
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_full_topic_with_http_info(guid, projects_pk, full_topic, **kwargs)  # noqa: E501
        else:
            (data) = self.update_full_topic_with_http_info(guid, projects_pk, full_topic, **kwargs)  # noqa: E501
            return data

    def update_full_topic_with_http_info(self, guid, projects_pk, full_topic, **kwargs):  # noqa: E501
        """Update some fields of a topic  # noqa: E501

        This is not a standard route. You can update topic, viewpoints and comment is a signle call Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_full_topic_with_http_info(guid, projects_pk, full_topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :param FullTopic full_topic: (required)
        :return: FullTopic
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'full_topic']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_full_topic" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `update_full_topic`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `update_full_topic`")  # noqa: E501
        # verify the required parameter 'full_topic' is set
        if ('full_topic' not in local_var_params or
                local_var_params['full_topic'] is None):
            raise ValueError("Missing the required parameter `full_topic` when calling `update_full_topic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'full_topic' in local_var_params:
            body_params = local_var_params['full_topic']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/full-topic/{guid}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FullTopic',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_topic(self, guid, projects_pk, topic, **kwargs):  # noqa: E501
        """Update some fields of a topic  # noqa: E501

        Update some fields of a topic Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_topic(guid, projects_pk, topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :param Topic topic: (required)
        :return: Topic
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_topic_with_http_info(guid, projects_pk, topic, **kwargs)  # noqa: E501
        else:
            (data) = self.update_topic_with_http_info(guid, projects_pk, topic, **kwargs)  # noqa: E501
            return data

    def update_topic_with_http_info(self, guid, projects_pk, topic, **kwargs):  # noqa: E501
        """Update some fields of a topic  # noqa: E501

        Update some fields of a topic Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_topic_with_http_info(guid, projects_pk, topic, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this topic. (required)
        :param str projects_pk: (required)
        :param Topic topic: (required)
        :return: Topic
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topic']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_topic" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `update_topic`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `update_topic`")  # noqa: E501
        # verify the required parameter 'topic' is set
        if ('topic' not in local_var_params or
                local_var_params['topic'] is None):
            raise ValueError("Missing the required parameter `topic` when calling `update_topic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'topic' in local_var_params:
            body_params = local_var_params['topic']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{guid}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Topic',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_viewpoint(self, guid, projects_pk, topics_pk, viewpoint, **kwargs):  # noqa: E501
        """Update some fields of a Viewpoint  # noqa: E501

        This is not a standard route. Update some fields of a Viewpoint Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_viewpoint(guid, projects_pk, topics_pk, viewpoint, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this viewpoint. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Viewpoint viewpoint: (required)
        :return: Viewpoint
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_viewpoint_with_http_info(guid, projects_pk, topics_pk, viewpoint, **kwargs)  # noqa: E501
        else:
            (data) = self.update_viewpoint_with_http_info(guid, projects_pk, topics_pk, viewpoint, **kwargs)  # noqa: E501
            return data

    def update_viewpoint_with_http_info(self, guid, projects_pk, topics_pk, viewpoint, **kwargs):  # noqa: E501
        """Update some fields of a Viewpoint  # noqa: E501

        This is not a standard route. Update some fields of a Viewpoint Required scopes: bcf:write  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_viewpoint_with_http_info(guid, projects_pk, topics_pk, viewpoint, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str guid: A UUID string identifying this viewpoint. (required)
        :param str projects_pk: (required)
        :param str topics_pk: (required)
        :param Viewpoint viewpoint: (required)
        :return: Viewpoint
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['guid', 'projects_pk', 'topics_pk', 'viewpoint']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_viewpoint" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'guid' is set
        if ('guid' not in local_var_params or
                local_var_params['guid'] is None):
            raise ValueError("Missing the required parameter `guid` when calling `update_viewpoint`")  # noqa: E501
        # verify the required parameter 'projects_pk' is set
        if ('projects_pk' not in local_var_params or
                local_var_params['projects_pk'] is None):
            raise ValueError("Missing the required parameter `projects_pk` when calling `update_viewpoint`")  # noqa: E501
        # verify the required parameter 'topics_pk' is set
        if ('topics_pk' not in local_var_params or
                local_var_params['topics_pk'] is None):
            raise ValueError("Missing the required parameter `topics_pk` when calling `update_viewpoint`")  # noqa: E501
        # verify the required parameter 'viewpoint' is set
        if ('viewpoint' not in local_var_params or
                local_var_params['viewpoint'] is None):
            raise ValueError("Missing the required parameter `viewpoint` when calling `update_viewpoint`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'guid' in local_var_params:
            path_params['guid'] = local_var_params['guid']  # noqa: E501
        if 'projects_pk' in local_var_params:
            path_params['projects_pk'] = local_var_params['projects_pk']  # noqa: E501
        if 'topics_pk' in local_var_params:
            path_params['topics_pk'] = local_var_params['topics_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'viewpoint' in local_var_params:
            body_params = local_var_params['viewpoint']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/bcf/2.1/projects/{projects_pk}/topics/{topics_pk}/viewpoints/{guid}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Viewpoint',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
